'
' translated from mandelbrot32-20180317-b.spin
'-------------------------------------------------------------------------------

'++
' constants (use const later)

  const xmin = -13349295 ' -0.79568
  const xmax = -13265409 ' -0.79068

  const ymin = -2740894  ' -0.16337
  const ymax = -2657008  ' -0.15837

  const maxiter = 255    ' 0..255

  const MPX = 599 ' 0..599
  const MPY = 599 ' 0..599

  const dx = (xmax-xmin)/MPX
  const dy = (ymax-ymin)/MPY

  const c4 = 4<<24
'--

'++
' was main
'
  dim x,y,x2,y2,cx,cy,iter as integer

  ' portable greymap header
  print"P2 ";MPX+1;" ";MPY+1;" ";maxiter+1

  cy = ymin
  for py = 0 to MPY
    cx = xmin
    for px = 0 to MPX
      x = 0
      y = 0
      iter = 0
      while iter<=maxiter
        x2 = hack.mul(x,x)
        y2 = hack.mul(y,y)
        if x2+y2>c4 goto breakwhile
        y = hack.multimes2(x,y)+cy
        x = x2-y2+cx
        iter = iter+1
      end while
breakwhile:
      cx = cx+dx
      print iter
    next px
    cy = cy+dy
  next py
'--

'++
class hacks input "mandelbrot32hacks.spin"
dim hack as hacks
' hack.mul(x,y) does s8p24 fp multiplication
' hack.multimes2(x,y) does mul(x,y)*2
'--
